Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4TritonEvaporationProbability.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4TritonEvaporationProbability.hh	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4TritonEvaporationProbability.hh	(revision 1347)
@@ -24,9 +24,16 @@
 // ********************************************************************
 //
-//J.M. Quesada (August2008). Based on:
+// $Id: G4TritonEvaporationProbability.hh,v 1.14 2010/11/17 11:06:03 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+// J.M. Quesada (August2008). Based on:
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Oct 1998)
 //
+// Modified:
+// 17-11-2010 V.Ivanchenko integer Z and A
+
+
 #ifndef G4TritonEvaporationProbability_h
 #define G4TritonEvaporationProbability_h 1
@@ -42,5 +49,6 @@
   G4TritonEvaporationProbability();
 
-  ~G4TritonEvaporationProbability() {}
+  virtual ~G4TritonEvaporationProbability();
+
 private:  
   // Copy constructor
@@ -54,35 +62,31 @@
 private:
 
-  virtual G4double CrossSection(const  G4Fragment & fragment, const  G4double K);
+  virtual G4double CrossSection(const G4Fragment & fragment, G4double K);
 
-  G4double GetOpt0(const G4double K);
-  G4double GetOpt12(const G4double K);
-  G4double GetOpt34(const G4double K);
+  G4double GetOpt0(G4double K);
+  G4double GetOpt12(G4double K);
+  G4double GetOpt34(G4double K);
 
   
- virtual G4double CalcAlphaParam(const G4Fragment & fragment)  ;
+  virtual G4double CalcAlphaParam(const G4Fragment & fragment)  ;
  
- virtual G4double CalcBetaParam(const G4Fragment & fragment)  ;
+  virtual G4double CalcBetaParam(const G4Fragment & fragment)  ;
  
-  G4double CCoeficient(const G4double aZ) ;
+  G4double CCoeficient(G4int aZ) ;
   
-//data members
+  //data members
+      
+  G4TritonCoulombBarrier theCoulombBarrier;
 
-      
-      G4TritonCoulombBarrier theCoulombBarrier;
-
-      G4double ResidualA;
-      G4double ResidualZ; 
-      G4double theA;
-      G4double theZ;
-      G4double ResidualAthrd;
-      G4double FragmentA;
-      G4double FragmentAthrd;
-
+  G4int ResidualA;
+  G4int ResidualZ; 
+  G4int theA;
+  G4int theZ;
+  G4double ResidualAthrd;
+  G4int FragmentA;
+  G4double FragmentAthrd;
 
 };
 
-
 #endif
 
-
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4UnstableFragmentBreakUp.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4UnstableFragmentBreakUp.hh	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4UnstableFragmentBreakUp.hh	(revision 1347)
@@ -25,5 +25,5 @@
 //
 // $Id: G4UnstableFragmentBreakUp.hh,v 1.2 2010/05/11 11:26:15 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4VEvaporation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4VEvaporation.hh	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4VEvaporation.hh	(revision 1347)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: G4VEvaporation.hh,v 1.6 2010/04/27 14:00:40 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// $Id: G4VEvaporation.hh,v 1.8 2010/11/17 11:06:03 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -66,7 +65,8 @@
   // for superimposed Coulomb Barrier for inverse cross sections 	
   inline void UseSICB(G4bool use) { useSICB = use; }	
+
 protected:
-   G4int OPTxs;
-   G4bool useSICB;
+  G4int OPTxs;
+  G4bool useSICB;
 
 };
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationChannel.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationChannel.cc	(revision 1347)
@@ -25,35 +25,19 @@
 //
 //
-// $Id: G4AlphaEvaporationChannel.cc,v 1.4 2006/06/29 20:10:17 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// $Id: G4AlphaEvaporationChannel.cc,v 1.5 2010/11/17 12:14:59 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Nov. 1999)
 //
+// 17-11-2010 V.Ivanchenko moved constructor and destructor to source and cleanup
 
 #include "G4AlphaEvaporationChannel.hh"
 
+G4AlphaEvaporationChannel::G4AlphaEvaporationChannel() 
+: G4EvaporationChannel(4,2,"alpha",&theEvaporationProbability,&theCoulombBarrier) 
+{}
 
-const G4AlphaEvaporationChannel & G4AlphaEvaporationChannel::operator=(const G4AlphaEvaporationChannel & )
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4AlphaEvaporationChannel::operator= meant to not be accessable");
-  return *this;
-}
+G4AlphaEvaporationChannel::~G4AlphaEvaporationChannel() 
+{}
 
-G4AlphaEvaporationChannel::G4AlphaEvaporationChannel(const G4AlphaEvaporationChannel & ) : G4EvaporationChannel()
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4AlphaEvaporationChannel::CopyConstructor meant to not be accessable");
-}
-
-G4bool G4AlphaEvaporationChannel::operator==(const G4AlphaEvaporationChannel &right ) const 
-{
-  return (this == (G4AlphaEvaporationChannel *) &right);
-  //  return false;
-}
-
-G4bool G4AlphaEvaporationChannel::operator!=(const G4AlphaEvaporationChannel &right ) const 
-{
-  return (this != (G4AlphaEvaporationChannel *) &right);
-  //  return true;
-}
-
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc	(revision 1347)
@@ -24,11 +24,15 @@
 // ********************************************************************
 //
-//J.M. Quesada (August2008). Based on:
+// $Id: G4AlphaEvaporationProbability.cc,v 1.18 2010/11/17 11:06:03 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+// J.M. Quesada (August2008). Based on:
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Oct 1998)
 //
-// Modif (03 September 2008) by J. M. Quesada for external choice of inverse 
-// cross section option
+// Modified:
+// 03-09-2008 J.M. Quesada for external choice of inverse cross section option
+// 17-11-2010 V.Ivanchenko integer Z and A
 
 #include "G4AlphaEvaporationProbability.hh"
@@ -36,64 +40,43 @@
 G4AlphaEvaporationProbability::G4AlphaEvaporationProbability() :
     G4EvaporationProbability(4,2,1,&theCoulombBarrier) // A,Z,Gamma,&theCoumlombBarrier
-{
+{}
+
+G4AlphaEvaporationProbability::~G4AlphaEvaporationProbability()
+{}
+
+G4double G4AlphaEvaporationProbability::CalcAlphaParam(const G4Fragment & fragment)  
+  { return 1.0 + CCoeficient(fragment.GetZ_asInt()-GetZ());}
 	
-}
-
-
-G4AlphaEvaporationProbability::G4AlphaEvaporationProbability(const G4AlphaEvaporationProbability &): G4EvaporationProbability()
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4AlphaEvaporationProbability::copy_constructor meant to not be accessable");
-}
-
-
-
-
-const G4AlphaEvaporationProbability & G4AlphaEvaporationProbability::
-operator=(const G4AlphaEvaporationProbability &) 
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4AlphaEvaporationProbability::operator= meant to not be accessable");
-    return *this;
-}
-
-
-G4bool G4AlphaEvaporationProbability::operator==(const G4AlphaEvaporationProbability &) const
-{
-    return false;
-}
-
-G4bool G4AlphaEvaporationProbability::operator!=(const G4AlphaEvaporationProbability &) const
-{
-    return true;
-}
-
-
- G4double G4AlphaEvaporationProbability::CalcAlphaParam(const G4Fragment & fragment)  
-  { return 1.0 + CCoeficient(static_cast<G4double>(fragment.GetZ()-GetZ()));}
+G4double G4AlphaEvaporationProbability::CalcBetaParam(const G4Fragment &) 
+  { return 0.0; }
+
+G4double G4AlphaEvaporationProbability::CCoeficient(G4int aZ) 
+{
+  // Data comes from 
+  // Dostrovsky, Fraenkel and Friedlander
+  // Physical Review, vol 116, num. 3 1959
+  // 
+  // const G4int size = 5;
+  // G4double Zlist[5] = { 10.0, 20.0, 30.0, 50.0, 70.0};
+  //	G4double Calpha[5] = { 0.10, 0.10, 0.10, 0.08, 0.06};
+  G4double C = 0.0;
 	
- G4double G4AlphaEvaporationProbability::CalcBetaParam(const G4Fragment &) 
-  { return 0.0; }
-
-G4double G4AlphaEvaporationProbability::CCoeficient(const G4double aZ) 
-{
-    // Data comes from 
-    // Dostrovsky, Fraenkel and Friedlander
-    // Physical Review, vol 116, num. 3 1959
-    // 
-    // const G4int size = 5;
-    // G4double Zlist[5] = { 10.0, 20.0, 30.0, 50.0, 70.0};
-    //	G4double Calpha[5] = { 0.10, 0.10, 0.10, 0.08, 0.06};
-    G4double C = 0.0;
-	
-	
-    if (aZ <= 30) {
-	C = 0.10;
-    } else if (aZ <= 50) {
-	C = 0.1 + -((aZ-50.)/20.)*0.02;
-    } else if (aZ < 70) {
-	C = 0.08 + -((aZ-70.)/20.)*0.02;
-    } else {
-	C = 0.06;
-    }
-    return C;
+  if (aZ <= 30) 
+    {
+      C = 0.10;
+    }
+  else if (aZ <= 50)
+    {
+      C = 0.1 - (aZ-30)*0.001;
+    }
+  else if (aZ < 70)
+    {
+      C = 0.08 - (aZ-50)*0.001;
+    }
+  else 
+    {
+      C = 0.06;
+    }
+  return C;
 }
 
@@ -104,16 +87,15 @@
 //OPT=3,4 Kalbach's parameterization 
 // 
-G4double G4AlphaEvaporationProbability::CrossSection(const  G4Fragment & fragment, 
-						     const  G4double K)
+G4double 
+G4AlphaEvaporationProbability::CrossSection(const G4Fragment & fragment, G4double K)
 {
   theA=GetA();
   theZ=GetZ();
-  ResidualA=fragment.GetA()-theA;
-  ResidualZ=fragment.GetZ()-theZ; 
-  
-  ResidualAthrd=std::pow(ResidualA,0.33333);
-  FragmentA=fragment.GetA();
-  FragmentAthrd=std::pow(FragmentA,0.33333);
-  
+  ResidualA=fragment.GetA_asInt()-theA;
+  ResidualZ=fragment.GetZ_asInt()-theZ; 
+  
+  ResidualAthrd=fG4pow->Z13(ResidualA);
+  FragmentA=fragment.GetA_asInt();
+  FragmentAthrd=fG4pow->Z13(FragmentA);
   
   if (OPTxs==0) {std::ostringstream errOs;
@@ -133,19 +115,17 @@
 }
 
-
-//
-//********************* OPT=1,2 : Chatterjee's cross section ************************ 
+//
+//********************* OPT=1,2 : Chatterjee's cross section ********************
 //(fitting to cross section from Bechetti & Greenles OM potential)
 
-G4double G4AlphaEvaporationProbability::GetOpt12(const  G4double K)
-{
-// c     ** alpha from huizenga and igo
+G4double G4AlphaEvaporationProbability::GetOpt12(G4double K)
+{
   G4double Kc=K;
-  
-  // JMQ xsec is set constat above limit of validity
-  if (K>50) Kc=50;
-  
+
+  // JMQ xsec is set constant above limit of validity
+  if (K > 50*MeV) { Kc = 50*MeV; }
+
   G4double landa ,mu ,nu ,p , Ec,q,r,ji,xs;
-  
+
   G4double     p0 = 10.95;
   G4double     p1 = -85.2;
@@ -160,37 +140,34 @@
   G4double     delta=1.2;          
 
- 
   Ec = 1.44*theZ*ResidualZ/(1.5*ResidualAthrd+delta);
   p = p0 + p1/Ec + p2/(Ec*Ec);
   landa = landa0*ResidualA + landa1;
-  mu = mu0*std::pow(ResidualA,mu1);
-  nu = std::pow(ResidualA,mu1)*(nu0 + nu1*Ec + nu2*(Ec*Ec));
+  G4double resmu1 = fG4pow->powZ(ResidualA,mu1); 
+  mu = mu0*resmu1;
+  nu = resmu1*(nu0 + nu1*Ec + nu2*(Ec*Ec));
   q = landa - nu/(Ec*Ec) - 2*p*Ec;
   r = mu + 2*nu/Ec + p*(Ec*Ec);
-  
+
   ji=std::max(Kc,Ec);
   if(Kc < Ec) { xs = p*Kc*Kc + q*Kc + r;}
   else {xs = p*(Kc - ji)*(Kc - ji) + landa*Kc + mu + nu*(2 - Kc/ji)/ji ;}
-                 
+  
   if (xs <0.0) {xs=0.0;}
-  
+              
   return xs;
-  
 }
 
 // *********** OPT=3,4 : Kalbach's cross sections (from PRECO code)*************
-G4double G4AlphaEvaporationProbability::GetOpt34(const  G4double K)
+G4double G4AlphaEvaporationProbability::GetOpt34(G4double K)
 // c     ** alpha from huizenga and igo
 {
-  
   G4double landa, mu, nu, p , signor(1.),sig;
   G4double ec,ecsq,xnulam,etest(0.),a; 
   G4double b,ecut,cut,ecut2,geom,elab;
 
-
   G4double     flow = 1.e-18;
   G4double     spill= 1.e+18;
 
-  G4double       p0 = 10.95;
+  G4double     p0 = 10.95;
   G4double     p1 = -85.2;
   G4double     p2 = 1146.;
@@ -204,5 +181,5 @@
   
   G4double      ra=1.20;
-  
+        
   //JMQ 13/02/09 increase of reduced radius to lower the barrier
   // ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
@@ -211,32 +188,33 @@
   p = p0 + p1/ec + p2/ecsq;
   landa = landa0*ResidualA + landa1;
-  a = std::pow(ResidualA,mu1);
+  a = fG4pow->powZ(ResidualA,mu1);
   mu = mu0 * a;
   nu = a* (nu0+nu1*ec+nu2*ecsq);  
   xnulam = nu / landa;
-  if (xnulam > spill) xnulam=0.;
-  if (xnulam >= flow) etest = 1.2 *std::sqrt(xnulam);
-  
+  if (xnulam > spill) { xnulam=0.; }
+  if (xnulam >= flow) { etest = 1.2 *std::sqrt(xnulam); }
+
   a = -2.*p*ec + landa - nu/ecsq;
   b = p*ecsq + mu + 2.*nu/ec;
   ecut = 0.;
   cut = a*a - 4.*p*b;
-  if (cut > 0.) ecut = std::sqrt(cut);
+  if (cut > 0.) { ecut = std::sqrt(cut); }
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
-//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
-//  if (cut < 0.) ecut2 = ecut - 2.;
-  if (cut < 0.) ecut2 = ecut;
-  elab = K * FragmentA / ResidualA;
+  //JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+  // ecut<0 means that there is no cut with energy axis, i.e. xs is set 
+  // to 0 bellow minimum
+  //  if (cut < 0.) ecut2 = ecut - 2.;
+  if (cut < 0.) { ecut2 = ecut; }
+  elab = K * FragmentA / G4double(ResidualA);
   sig = 0.;
   
   if (elab <= ec) { //start for E<Ec
-    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;
+    if (elab > ecut2) { sig = (p*elab*elab+a*elab+b) * signor; }
   }           //end for E<Ec
   else {           //start for E>Ec
     sig = (landa*elab+mu+nu/elab) * signor;
     geom = 0.;
-    if (xnulam < flow || elab < etest) return sig;
+    if (xnulam < flow || elab < etest) { return sig; }
     geom = std::sqrt(theA*K);
     geom = 1.23*ResidualAthrd + ra + 4.573/geom;
@@ -245,6 +223,4 @@
   }           //end for E>Ec
   return sig;
-  
-}
-
-//   ************************** end of cross sections ******************************* 
+}
+
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationChannel.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationChannel.cc	(revision 1347)
@@ -25,34 +25,19 @@
 //
 //
-// $Id: G4DeuteronEvaporationChannel.cc,v 1.4 2006/06/29 20:10:21 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// $Id: G4DeuteronEvaporationChannel.cc,v 1.5 2010/11/17 12:14:59 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Nov. 1999)
 //
+// 17-11-2010 V.Ivanchenko moved constructor and destructor to source and cleanup
 
 #include "G4DeuteronEvaporationChannel.hh"
 
+G4DeuteronEvaporationChannel::G4DeuteronEvaporationChannel() 
+: G4EvaporationChannel(2,1,"deuteron",&theEvaporationProbability,&theCoulombBarrier) 
+{}
 
-const G4DeuteronEvaporationChannel & G4DeuteronEvaporationChannel::operator=(const G4DeuteronEvaporationChannel & )
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4DeuteronEvaporationChannel::operator= meant to not be accessable");
-    return *this;
-}
+G4DeuteronEvaporationChannel::~G4DeuteronEvaporationChannel() 
+{}
 
-G4DeuteronEvaporationChannel::G4DeuteronEvaporationChannel(const G4DeuteronEvaporationChannel & ) : G4EvaporationChannel()
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4DeuteronEvaporationChannel::CopyConstructor meant to not be accessable");
-}
-
-G4bool G4DeuteronEvaporationChannel::operator==(const G4DeuteronEvaporationChannel & right) const 
-{
-    return (this == (G4DeuteronEvaporationChannel *) &right);
-    //  return false;
-}
-
-G4bool G4DeuteronEvaporationChannel::operator!=(const G4DeuteronEvaporationChannel & right) const 
-{
-    return (this != (G4DeuteronEvaporationChannel *) &right);
-    //  return true;
-}
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc	(revision 1347)
@@ -24,11 +24,15 @@
 // ********************************************************************
 //
-//J.M. Quesada (August2008). Based on:
+// $Id: G4DeuteronEvaporationProbability.cc,v 1.20 2010/11/17 11:06:03 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
+//
+// J.M. Quesada (August2008). Based on:
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Oct 1998)
 //
-// Modif (03 September 2008) by J. M. Quesada for external choice of inverse 
-// cross section option
+// Modified:
+// 03-09-2008 J.M. Quesada for external choice of inverse cross section option
+// 17-11-2010 V.Ivanchenko integer Z and A
 
 
@@ -38,62 +42,38 @@
 G4DeuteronEvaporationProbability::G4DeuteronEvaporationProbability() :
     G4EvaporationProbability(2,1,3,&theCoulombBarrier) // A,Z,Gamma (fixed JMQ)
-{    	}
-G4DeuteronEvaporationProbability::G4DeuteronEvaporationProbability(const G4DeuteronEvaporationProbability &) : G4EvaporationProbability()
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4DeuteronEvaporationProbability::copy_constructor meant to not be accessable");
-}
-
-
-const G4DeuteronEvaporationProbability & G4DeuteronEvaporationProbability::
-operator=(const G4DeuteronEvaporationProbability &)
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4DeuteronEvaporationProbability::operator= meant to not be accessable");
-    return *this;
-}
-
-
-G4bool G4DeuteronEvaporationProbability::operator==(const G4DeuteronEvaporationProbability &) const
-{
-    return false;
-}
-
-
-G4bool G4DeuteronEvaporationProbability::operator!=(const G4DeuteronEvaporationProbability &) const
-{
-    return true;
-}
-
+{}
+
+G4DeuteronEvaporationProbability::~G4DeuteronEvaporationProbability()
+{}
 
 G4double G4DeuteronEvaporationProbability::CalcAlphaParam(const G4Fragment & fragment) 
 {
-    return 1.0 + CCoeficient(static_cast<G4double>(fragment.GetZ()-GetZ()));
-}
-
+  return 1.0 + CCoeficient(fragment.GetZ_asInt()-GetZ());
+}
 
 G4double G4DeuteronEvaporationProbability::CalcBetaParam(const G4Fragment & ) 
 {
-    return 0.0;
-}
-
-
-G4double G4DeuteronEvaporationProbability::CCoeficient(const G4double aZ) 
-{
-    // Data comes from 
-    // Dostrovsky, Fraenkel and Friedlander
-    // Physical Review, vol 116, num. 3 1959
-    // 
-    // const G4int size = 5;
-    // G4double Zlist[5] = { 10.0, 20.0, 30.0, 50.0, 70.0};
-    // G4double Cp[5] = { 0.50, 0.28, 0.20, 0.15, 0.10};
-    // C for deuteron is equal to C for protons divided by 2
-    G4double C = 0.0;
+  return 0.0;
+}
+
+G4double G4DeuteronEvaporationProbability::CCoeficient(G4int aZ) 
+{
+  // Data comes from 
+  // Dostrovsky, Fraenkel and Friedlander
+  // Physical Review, vol 116, num. 3 1959
+  // 
+  // const G4int size = 5;
+  // G4double Zlist[5] = { 10.0, 20.0, 30.0, 50.0, 70.0};
+  // G4double Cp[5] = { 0.50, 0.28, 0.20, 0.15, 0.10};
+  // C for deuteron is equal to C for protons divided by 2
+  G4double C = 0.0;
 	
-    if (aZ >= 70) {
-	C = 0.10;
-    } else {
-	C = ((((0.15417e-06*aZ) - 0.29875e-04)*aZ + 0.21071e-02)*aZ - 0.66612e-01)*aZ + 0.98375;
-    }
+  if (aZ >= 70) {
+    C = 0.10;
+  } else {
+    C = ((((0.15417e-06*aZ) - 0.29875e-04)*aZ + 0.21071e-02)*aZ - 0.66612e-01)*aZ + 0.98375;
+  }
 	
-    return C/2.0;
+  return C/2.0;
 	
 }
@@ -106,89 +86,85 @@
 //OPT=3,4 Kalbach's parameterization 
 // 
-G4double G4DeuteronEvaporationProbability::CrossSection(const  G4Fragment & fragment, const  G4double K)
-{
-       theA=GetA();
-       theZ=GetZ();
-       ResidualA=fragment.GetA()-theA;
-       ResidualZ=fragment.GetZ()-theZ; 
+G4double 
+G4DeuteronEvaporationProbability::CrossSection(const  G4Fragment & fragment, G4double K)
+{
+  theA=GetA();
+  theZ=GetZ();
+  ResidualA=fragment.GetA_asInt()-theA;
+  ResidualZ=fragment.GetZ_asInt()-theZ; 
+  
+  ResidualAthrd=fG4pow->Z13(ResidualA);
+  FragmentA=fragment.GetA_asInt();
+  FragmentAthrd=fG4pow->Z13(FragmentA);
+
+  if (OPTxs==0) {std::ostringstream errOs;
+  errOs << "We should'n be here (OPT =0) at evaporation cross section calculation (deuterons)!!"  
+	<<G4endl;
+  throw G4HadronicException(__FILE__, __LINE__, errOs.str());
+  return 0.;}
+  if( OPTxs==1 || OPTxs==2) return G4DeuteronEvaporationProbability::GetOpt12( K);
+  else if (OPTxs==3 || OPTxs==4)  return G4DeuteronEvaporationProbability::GetOpt34( K);
+  else{
+    std::ostringstream errOs;
+    errOs << "BAD Deuteron CROSS SECTION OPTION AT EVAPORATION!!"  <<G4endl;
+    throw G4HadronicException(__FILE__, __LINE__, errOs.str());
+    return 0.;
+  }
+}
+
+//
+//********************* OPT=1,2 : Chatterjee's cross section ********************
+//(fitting to cross section from Bechetti & Greenles OM potential)
+
+G4double G4DeuteronEvaporationProbability::GetOpt12(G4double K)
+{
+  G4double Kc = K;
+
+  // JMQ xsec is set constat above limit of validity
+  if (K > 50*MeV) { Kc = 50*MeV; }
+
+  G4double landa ,mu ,nu ,p , Ec,q,r,ji,xs;
  
-       ResidualAthrd=std::pow(ResidualA,0.33333);
-       FragmentA=fragment.GetA();
-       FragmentAthrd=std::pow(FragmentA,0.33333);
-
-       if (OPTxs==0) {std::ostringstream errOs;
-         errOs << "We should'n be here (OPT =0) at evaporation cross section calculation (deuterons)!!"  <<G4endl;
-         throw G4HadronicException(__FILE__, __LINE__, errOs.str());
-         return 0.;}
-       if( OPTxs==1 || OPTxs==2) return G4DeuteronEvaporationProbability::GetOpt12( K);
-       else if (OPTxs==3 || OPTxs==4)  return G4DeuteronEvaporationProbability::GetOpt34( K);
-       else{
-         std::ostringstream errOs;
-         errOs << "BAD Deuteron CROSS SECTION OPTION AT EVAPORATION!!"  <<G4endl;
-         throw G4HadronicException(__FILE__, __LINE__, errOs.str());
-         return 0.;
-       }
-}
-
-
-//********************* OPT=1,2 : Chatterjee's cross section ************************ 
-//(fitting to cross section from Bechetti & Greenles OM potential)
-
-G4double G4DeuteronEvaporationProbability::GetOpt12(const  G4double K)
-{
-
-  G4double Kc=K;
-
-// JMQ xsec is set constat above limit of validity
- if (K>50) Kc=50;
-
- G4double landa ,mu ,nu ,p , Ec,q,r,ji,xs;
-
- 
- G4double    p0 = -38.21;
- G4double    p1 = 922.6;
- G4double    p2 = -2804.;
- G4double    landa0 = -0.0323;
- G4double    landa1 = -5.48;
- G4double    mu0 = 336.1;
- G4double    mu1 = 0.48;
- G4double    nu0 = 524.3;
- G4double    nu1 = -371.8;
- G4double    nu2 = -5.924;  
- G4double    delta=1.2;            
- 
-
- Ec = 1.44*theZ*ResidualZ/(1.5*ResidualAthrd+delta);
- p = p0 + p1/Ec + p2/(Ec*Ec);
- landa = landa0*ResidualA + landa1;
- mu = mu0*std::pow(ResidualA,mu1);
- nu = std::pow(ResidualA,mu1)*(nu0 + nu1*Ec + nu2*(Ec*Ec));
- q = landa - nu/(Ec*Ec) - 2*p*Ec;
- r = mu + 2*nu/Ec + p*(Ec*Ec);
- 
- ji=std::max(Kc,Ec);
- if(Kc < Ec) { xs = p*Kc*Kc + q*Kc + r;}
- else {xs = p*(Kc - ji)*(Kc - ji) + landa*Kc + mu + nu*(2 - Kc/ji)/ji ;}
+  G4double    p0 = -38.21;
+  G4double    p1 = 922.6;
+  G4double    p2 = -2804.;
+  G4double    landa0 = -0.0323;
+  G4double    landa1 = -5.48;
+  G4double    mu0 = 336.1;
+  G4double    mu1 = 0.48;
+  G4double    nu0 = 524.3;
+  G4double    nu1 = -371.8;
+  G4double    nu2 = -5.924;  
+  G4double    delta=1.2;            
+
+  Ec = 1.44*theZ*ResidualZ/(1.5*ResidualAthrd+delta);
+  p = p0 + p1/Ec + p2/(Ec*Ec);
+  landa = landa0*ResidualA + landa1;
+  G4double resmu1 = fG4pow->powZ(ResidualA,mu1); 
+  mu = mu0*resmu1;
+  nu = resmu1*(nu0 + nu1*Ec + nu2*(Ec*Ec));
+  q = landa - nu/(Ec*Ec) - 2*p*Ec;
+  r = mu + 2*nu/Ec + p*(Ec*Ec);
+
+  ji=std::max(Kc,Ec);
+  if(Kc < Ec) { xs = p*Kc*Kc + q*Kc + r;}
+  else {xs = p*(Kc - ji)*(Kc - ji) + landa*Kc + mu + nu*(2 - Kc/ji)/ji ;}
                  
- if (xs <0.0) {xs=0.0;}
- 
- return xs;
-
-}
-
+  if (xs <0.0) {xs=0.0;}
+              
+  return xs;
+}
 
 // *********** OPT=3,4 : Kalbach's cross sections (from PRECO code)*************
-G4double G4DeuteronEvaporationProbability::GetOpt34(const  G4double K)
+G4double G4DeuteronEvaporationProbability::GetOpt34(G4double K)
 //     ** d from o.m. of perey and perey
 {
 
-  G4double landa, mu, nu, p , signor(1.),sig;
+  G4double landa, mu, nu, p ,signor(1.),sig;
   G4double ec,ecsq,xnulam,etest(0.),a; 
   G4double b,ecut,cut,ecut2,geom,elab;
 
-
   G4double     flow = 1.e-18;
   G4double     spill= 1.e+18;
-
 
   G4double     p0 = 0.798;
@@ -202,20 +178,19 @@
   G4double     nu1 = -474.5;
   G4double     nu2 = -3.592;      
-  
-  G4double      ra=0.80;
+ 
+  G4double     ra=0.80;
         
   //JMQ 13/02/09 increase of reduced radius to lower the barrier
-  //  ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
-   ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
-
+  // ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+  ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
   ecsq = ec * ec;
   p = p0 + p1/ec + p2/ecsq;
   landa = landa0*ResidualA + landa1;
-  a = std::pow(ResidualA,mu1);
+  a = fG4pow->powZ(ResidualA,mu1);
   mu = mu0 * a;
   nu = a* (nu0+nu1*ec+nu2*ecsq);  
   xnulam = nu / landa;
-  if (xnulam > spill) xnulam=0.;
-  if (xnulam >= flow) etest = 1.2 *std::sqrt(xnulam);
+  if (xnulam > spill) { xnulam=0.; }
+  if (xnulam >= flow) { etest = 1.2 *std::sqrt(xnulam); }
 
   a = -2.*p*ec + landa - nu/ecsq;
@@ -223,21 +198,22 @@
   ecut = 0.;
   cut = a*a - 4.*p*b;
-  if (cut > 0.) ecut = std::sqrt(cut);
+  if (cut > 0.) { ecut = std::sqrt(cut); }
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
-//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
-//  if (cut < 0.) ecut2 = ecut - 2.;
-  if (cut < 0.) ecut2 = ecut;
-  elab = K * FragmentA / ResidualA;
+  //JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+  //ecut<0 means that there is no cut with energy axis, i.e. xs is set 
+  //to 0 bellow minimum
+  //  if (cut < 0.) ecut2 = ecut - 2.;
+  if (cut < 0.) { ecut2 = ecut; }
+  elab = K * FragmentA / G4double(ResidualA);
   sig = 0.;
 
   if (elab <= ec) { //start for E<Ec
-    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;
+    if (elab > ecut2) { sig = (p*elab*elab+a*elab+b) * signor; }
   }           //end for E<Ec
   else {           //start for E>Ec
     sig = (landa*elab+mu+nu/elab) * signor;
     geom = 0.;
-    if (xnulam < flow || elab < etest) return sig;
+    if (xnulam < flow || elab < etest) { return sig; }
     geom = std::sqrt(theA*K);
     geom = 1.23*ResidualAthrd + ra + 4.573/geom;
@@ -246,6 +222,4 @@
   }           //end for E>Ec
   return sig;
-  
-}
-
-//   ************************** end of cross sections ******************************* 
+}
+
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4Evaporation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4Evaporation.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4Evaporation.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Evaporation.cc,v 1.25 2010/06/09 11:56:47 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// $Id: G4Evaporation.cc,v 1.26 2010/11/23 18:10:10 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -142,10 +142,10 @@
     G4int Z = theResidualNucleus->GetZ_asInt();
     G4double abun = nist->GetIsotopeAbundance(Z, A); 
-    /*
-    G4cout << "### G4Evaporation::BreakItUp step " << ia << " Z= " << Z
-	   << " A= " << A << " Eex(MeV)= " 
-	   << theResidualNucleus->GetExcitationEnergy()
-	   << " aban= " << abun << G4endl;
-    */
+    
+    // G4cout << "### G4Evaporation::BreakItUp step " << ia << " Z= " << Z
+    //	   << " A= " << A << " Eex(MeV)= " 
+    //	   << theResidualNucleus->GetExcitationEnergy()
+    //	   << " aban= " << abun << G4endl;
+   
     if(theResidualNucleus->GetExcitationEnergy() <= minExcitation && 
        (abun > 0.0)) 
@@ -184,4 +184,5 @@
     // do evaporation chain and reset total probability
     if(0.0 < totprob && probabilities[0] == totprob) {
+      //G4cout << "Start gamma evaporation" << G4endl;
       theTempResult = (*theChannels)[0]->BreakUpFragment(theResidualNucleus);
       if(theTempResult) {
@@ -228,4 +229,5 @@
     // single photon evaporation, primary pointer is kept
     if(0 == i) {
+      //G4cout << "Single gamma" << G4endl;
       G4Fragment* gamma = (*theChannels)[0]->EmittedFragment(theResidualNucleus);
       if(gamma) { theResult->push_back(gamma); }
@@ -233,4 +235,5 @@
       // fission, return results to the main loop if fission is succesful
     } else if(1 == i) {
+      //G4cout << "Fission" << G4endl;
       theTempResult = (*theChannels)[1]->BreakUp(*theResidualNucleus);
       if(theTempResult) {
@@ -248,4 +251,5 @@
       // other channels
     } else {
+      //G4cout << "Channel # " << i << G4endl;
       theTempResult = (*theChannels)[i]->BreakUp(*theResidualNucleus);
       if(theTempResult) {
